#DEFINE WM_INPUTLANGCHANGE	0x0051

PUBLIC goForm as Form
goForm = NEWOBJECT('FrmChangeKeyboardLayout')
IF VARTYPE(goForm) # 'O'
	RELEASE goForm
	RETURN .F.
ENDIF
goForm.Show()
 	 

DEFINE CLASS FrmChangeKeyboardLayout AS form

	Name = "FrmChangeKeyboardLayout"
	Height = 42
	Width = 214
	AutoCenter = .T.
	BorderStyle = 2
	Caption = "Try change KeyboardLayout"
	MaxButton = .F.
	MinButton = .F.
	KeyPreview = .T.


	ADD OBJECT lblKeyboardLayout AS label WITH ;
		FontSize = 8, ;
		BackStyle = 0, ;
		Caption = "Current KeyboardLayout:", ;
		Height = 16, ;
		Left = 9, ;
		Top = 12, ;
		Width = 123, ;
		Name = "lblKeyboardLayout"


	ADD OBJECT txtKeyboardLayout AS textbox WITH ;
		FontSize = 8, ;
		Height = 20, ;
		Left = 134, ;
		ReadOnly = .T., ;
		Top = 10, ;
		Width = 71, ;
		Name = "txtKeyboardLayout"


	PROCEDURE Load
		IF VERSION(5) < 900
			MESSAGEBOX("Sorry, this test for VFP 9.0 or later.", 16, _SCREEN.Caption)
			RETURN .F.
		ENDIF
	ENDPROC


	PROCEDURE Init
		DECLARE INTEGER GetKeyboardLayout IN Win32API Integer
		BINDEVENT(thisForm.HWnd, WM_INPUTLANGCHANGE, thisForm, 'LangChanged')
	ENDPROC


	PROTECTED PROCEDURE ShowChange
		this.txtKeyboardLayout.Value = TRANSFORM(GetKeyboardLayout(0), '@0')
	ENDPROC


	PROCEDURE Refresh
		this.ShowChange()   
	ENDPROC


	PROTECTED PROCEDURE LangChanged
		LPARAMETERS hWnd, nMsg, wParam, lParam
		this.Refresh()   
	ENDPROC


	PROCEDURE Paint
		this.Refresh()   
	ENDPROC


	PROCEDURE KeyPress
		LPARAMETERS nKeyCode, nShiftAltCtrl
		IF nKeyCode = 27
			thisForm.Release() 
			NODEFAULT
		ENDIF
	ENDPROC


	PROCEDURE Unload
		UNBINDEVENTS(thisForm.HWnd)  
		CLEAR DLLS 'GetKeyboardLayout'
		RELEASE goForm 
	ENDPROC
	
ENDDEFINE